﻿Type=Class
Version=3.61
ModulesStructureVersion=1
B4J=true
@EndOfDesignText@
'Class module
Sub Class_Globals
	Private MyRect As Rect
	Private Others As List
	Private checkInterval, interval As Int
	Private safeZone As Int
End Sub

Public Sub Initialize (vMyRect As Rect, vOthers As List, vCheckInterval As Int, vSafeZone As Int)
	MyRect = vMyRect
	'Others is a list of objects. Each object should have a GetRect sub such as: 
	'Public Sub GetRect As Rect
	'	return bd.DestRect
	'End Sub
	'Note that this class holds a reference to the list. This means that if later an object is added or removed
	'then it will automatically affect this class as well.
	Others = vOthers
	'Check for collision every x ticks. If the objects do not move too fast there is no point
	'in checking for collision every tick.
	checkInterval = vCheckInterval
	'As each sprite is treated as a rectangle you may want to decrease the rectangle size to avoid cases
	'where the collision is in two corners for example.
	safeZone = vSafeZone
End Sub

'Checks for collisions. Returns the collided object if there was a collision
Public Sub Tick As Object
	interval = interval + 1
	If interval = checkInterval Then
		interval = 0
		For i = 0 To Others.Size - 1
			Dim OtherRect As Rect = CallSub(Others.Get(i), "GetRect")
			If IsCollided(MyRect, OtherRect) Then
				'Log("collide")
				Return Others.Get(i)
			End If
		Next
	End If
	Return Null
End Sub

Private Sub IsCollided(Rect1 As Rect, Rect2 As Rect) As Boolean
'	Log($"Rect1: ${Rect1.Left}, ${Rect1.Top}, ${Rect1.Right}, ${Rect1.Bottom}"$)
'	Log($"Rect2: ${Rect2.Left}, ${Rect2.Top}, ${Rect2.Right}, ${Rect2.Bottom}"$)
	Return Rect1.Left < Rect2.Right - safeZone And Rect1.Right > Rect2.Left + safeZone _
		And Rect1.Top < Rect2.Bottom - safeZone And Rect1.Bottom > Rect2.Top + safeZone
End Sub

