﻿Type=Class
Version=3.61
ModulesStructureVersion=1
B4J=true
@EndOfDesignText@
'SpriteAnimator is a utility class that can move and animate sprites.

Sub Class_Globals
	'An array with the source rectangles. This is useful when working with sprite sheets.
	Private srcRects() As Rect
	'An array with the animation frames.
	Private bitmaps() As Image
	Private index As Int
	Private interval As Int
	
	'Change frame each x ticks
	Public AnimationInterval As Int
	Public vx, vy As Double
	Private gv As GameView
	Private mWidth, mHeight As Double
End Sub

Public Sub Initialize (GameView As GameView, Width As Double, Height As Double)
	AnimationInterval = 1
	gv = GameView
	mWidth = Width
	mHeight = Height
End Sub

Public Sub SetFrames(bd As BitmapData, vSrcRects() As Rect, vBitmaps() As Image)
	srcRects = vSrcRects
	bitmaps = vBitmaps
	bd.SrcRect = srcRects(0) 'start with the first frame
	bd.Bitmap = bitmaps(0)
	index = 0
	interval = 0
	bd.DestRect.Width = mWidth
	bd.DestRect.Height = mHeight
End Sub

Public Sub Tick (bd As BitmapData)
	'move the sprite based on vx and vy
	bd.DestRect.Left = bd.DestRect.Left + vx
	bd.DestRect.Top = bd.DestRect.Top + vy
	
	'in this game objects that go out of the screen return from the other side:
	If vx > 0 And bd.DestRect.CenterX > gv.Width Then 
		bd.DestRect.Left = -mWidth / 2
	Else If vx < 0 And bd.DestRect.CenterX < 0 Then
		bd.DestRect.Left = gv.Width + mWidth / 2
	End If
	
	If vy > 0 And bd.DestRect.CenterY > gv.Height Then
		bd.DestRect.Top = -mHeight / 2
	Else If vy < 0 And bd.DestRect.CenterY < 0 Then
		bd.DestRect.Top = gv.Height + mHeight / 2
	End If
	interval = interval + 1
	If AnimationInterval = interval Then
		'change the animation frame.
		interval = 0
		index = (index + 1) Mod bitmaps.Length
		bd.SrcRect = srcRects(index)
		bd.Bitmap = bitmaps(index)
		If bd.SrcRect.Width = 0 Then
			bd.SrcRect = GameUtils.CreateRect(0, 0, bd.Bitmap.Width, bd.Bitmap.Height)
		End If
	End If
End Sub

Public Sub getWidth As Double
	Return mWidth
End Sub

Public Sub getHeight As Double
	Return mHeight
End Sub


